---
title: Function.prototype.toSource()
slug: Web/JavaScript/Reference/Global_Objects/Function/toSource
tags:
  - Function
  - JavaScript
  - Method
  - Non-standard
  - Obsolete
---
<div>{{JSRef}} {{obsolete_header}}</div>

<p>The <strong><code>toSource()</code></strong> method returns a string representing the source code of the object. This method is usually called internally by JavaScript and not explicitly in code. You can call <code>toSource()</code> while debugging to examine the contents of an object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>function</var>.toSource();
</pre>

<h3 id="Return_value">Return value</h3>

<p>A string representing the source code of the object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Native_functions">Native functions</h3>

<p>For the built-in {{jsxref("Function")}} object, <code>toSource()</code> returns the following string indicating that the source code is not available:</p>

<pre class="brush: js notranslate">function Function() {
  [native code]
}
</pre>

<h3 id="Custom_functions">Custom functions</h3>

<p>For custom functions, <code>toSource()</code> returns the JavaScript source that defines the object as a string.</p>

<pre class="brush: js notranslate">// For example:
function hello() {
  console.log("Hello, World!");
}

hello.toSource();
</pre>

<pre class="brush: js notranslate">// Results in:
"function hello() {
    console.log(\"Hello, World!\");
}"</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Function.toSource")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.prototype.toSource()")}}</li>
</ul>
